<template>
  <v-dialog v-model="dialog" max-width="500px">
    <template v-slot:activator="{ on, attrs }">
      <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">
        New Item
      </v-btn>
    </template>
    <v-card>
      <v-card-title>
        <span class="headline">{{ formTitle }}</span>
      </v-card-title>

      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.id"
                label="character id"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.name"
                label="character name"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.status"
                label="character status"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.species"
                label="character species"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.type"
                label="character type"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.gender"
                label="character gender"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.origin"
                label="character origin"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="4">
              <v-text-field
                v-model="editedItem.location"
                label="character location"
              ></v-text-field>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="close"> Cancel </v-btn>
        <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import {mapState, mapActions } from "vuex";
export default {
  name:"AddEditItem",
  computed: {
    ...mapState({
      editedItem: state => state.editedItem,
      editedIndex: state => state.editedIndex,
      users: state => state.users,
      dialogState: state => state.dialog.dialog
    }),
    dialog: {
           get(){
             return this.dialogState
           },
           set(value){
             return this.SET_DIALOG({"key":"dialog", value});
           } 
        },
    formTitle() {
      return this.editedIndex === -1 ? "New Item" : "Edit Item";
    }
  },
  data () {
      return {
      
    // dialog: false,
    defaultItem: {
      id: "",
      name: "",
      status: "",
      species: "",
      type: "",
      genter: "",
      origin: "",
      location: "",
    },
      }
  },
  methods: {
    ...mapActions(["SET_EDITED_ITEM","SET_EDITED_INDEX","MODIFY_USERS","SET_DIALOG"]),
    close() {
      this.SET_DIALOG({key:"dialog", value:false})
      console.log("dialog", this.dialog)
      this.$nextTick(() => {
        this.SET_EDITED_ITEM(Object.assign({}, this.defaultItem));
        this.SET_EDITED_INDEX(-1)
      });
    },
    save() {
      if (this.editedIndex > -1) {
        this.MODIFY_USERS({operation:'merge', value: Object.assign(this.users[this.editedIndex], this.editedItem)})
      } else {
        this.MODIFY_USERS({operation:'push', value:this.editedItem})
        console.log("PUSH")
      }
      this.close();
    }
  },
  watch: {
    dialog(val) {
      console.log("watch", val)
      val || this.close();
    }
  },
};
</script>

<style>
</style>